package Alunos;

public abstract class Aluno
{
    private int conhecimento = 0;
    private String nome;
    private RelaQueue queue;
    private static int numAlunos = 0;
 
    public static int numAlunos() {
        return numAlunos;
    }
    
    //contrutor da classe
    //seta nome e pega referencia à fila de relatorios
    public Aluno(String nome, RelaQueue queue)
    {
        this.nome = nome;
        this.queue = queue;
        this.numAlunos++;
    }   
 
    //metodo abstrato para retornar a inteligencia
    public abstract float getInteligencia();
 
    //metodo abstrato para retornar a dedicação
    public abstract float getDedicacao();
 
    //retorna o nome
    public String getNome() 
    {
        return this.nome;
    }
 
    //retorna o conhecimento
    public int getConhecimento()
    {
        return this.conhecimento;
    }
 
    //gera um novo relatorio e coloca na fila de relatorios
    public void fazEEntregaRelatorio()
    {
            float qualidade = (2 * this.getDedicacao() + 1 * this.getInteligencia() ) / 3 ;
            float originalidade = (1 * this.getDedicacao() + 2 * this.getInteligencia() ) / 3 ;
        queue.queue(new Relatorio(qualidade, originalidade, this));        
    }
}
